import 'package:json_annotation/json_annotation.dart';
import 'package:equatable/equatable.dart';

part 'update_model.g.dart';

@JsonSerializable()
class UpdateModel extends Equatable {
  final int updateStatus;
  final int versionCode;
  final String versionName;
  final String modifyContent;
  final String downloadUrl;
  final String apkSize;
  final String apkMd5;

  factory UpdateModel.fromJson(Map<String, dynamic> json) =>
      _$UpdateModelFromJson(json);


  const UpdateModel({
    required this.updateStatus,
    required this.versionCode,
    required this.versionName,
    required this.modifyContent,
    required this.downloadUrl,
    required this.apkSize,
    required this.apkMd5,
  });

  @override
  List<Object?> get props => [
        updateStatus,
        versionCode,
        versionName,
        modifyContent,
        downloadUrl,
        apkSize,
        apkMd5,
      ];
}
